#include <SoftwareSerial.h>

#define SERIAL_BAUD 9600
#define rxPin 10
#define txPin 11
static SoftwareSerial mySerial(rxPin, txPin);

int incomingByte = 0;
char sendCommand;
int con, state, main_ver, minor_ver;
long distance;

void setup() {
  Serial.begin(SERIAL_BAUD);
  mySerial.begin(SERIAL_BAUD);

  //  Read_ver();
  Start_CMD();
}

void loop() {
  Do_Ranging();
}

void Read_ver()
{
  //Start
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x04;
  mySerial.write(sendCommand);
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x18;
  mySerial.write(sendCommand);
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x02;
  mySerial.write(sendCommand);
  sendCommand = 0xF0;
  mySerial.write(sendCommand);
  sendCommand = 0x1D;
  mySerial.write(sendCommand);
  delay(50); //ranging processing wait

  con = 0;
  distance = 0;
  state = 0;
  main_ver = 0;
  minor_ver = 0;

  while (true) {
    if (mySerial.available() > 0)
    {
      incomingByte = mySerial.read();
      //      Serial.print(incomingByte, HEX);
      //      Serial.print(" ");

      con++;//get next data
      if (con == 4) {
        main_ver = incomingByte;
      }

      if (con == 5) {
        main_ver = (main_ver << 8) + incomingByte;
        Serial.print("Version: Main:");
        Serial.print(main_ver, DEC);
      }

      if (con == 6) {
        main_ver = incomingByte;
      }

      if (con == 7) {
        minor_ver = (minor_ver << 8) + incomingByte;
        Serial.print(" Minor:");
        Serial.print(minor_ver, DEC);
      }
    }
  }
}

void Start_CMD()
{
  //Start
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x06;
  mySerial.write(sendCommand);
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x02;
  mySerial.write(sendCommand);
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x01;
  mySerial.write(sendCommand);
  sendCommand = 0xE8;
  mySerial.write(sendCommand);
  sendCommand = 0x1B;
  mySerial.write(sendCommand);
  delay(50); //ranging processing wait
}

void Do_Ranging()
{
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x04;
  mySerial.write(sendCommand);
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x00;
  mySerial.write(sendCommand);
  sendCommand = 0x02;
  mySerial.write(sendCommand);
  sendCommand = 0x70;
  mySerial.write(sendCommand);
  sendCommand = 0x1A;
  mySerial.write(sendCommand);

  con = 0;
  distance = 0;
  state = 0;

  while (true) {
    if (mySerial.available() > 0)
    {
      incomingByte = mySerial.read();
      //      Serial.print(incomingByte, HEX);
      //      Serial.print(" ");

      con++;//get next data
      if (con == 4) {
        distance = incomingByte;
      }

      if (con == 5) {
        distance = (distance << 8) + incomingByte;
        if (distance != 8888) {
          Serial.print(distance, DEC);
          Serial.print(" mm, ");
        } else {
          Serial.print(distance, DEC);
          Serial.print(" ");
        }
      }

      if (con == 6) {
        state = incomingByte;
      }
      if (con == 7) {
        state = (state << 8) + incomingByte;
        Serial.print("state : ");
        Serial.print(state, HEX);
      }

    } else {
      Serial.println();
      break;
    }
  }
  delay(55); //ranging processing wait
}
